package Loove 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	import net.flashpunk.tweens.misc.NumTween;
	import net.flashpunk.utils.Ease;
	
	import net.flashpunk.FP;
		
	public class BondingOverlay extends Entity
	{
		[Embed(source = '../../assets/Loove_Player_Bonding_v1.png')] private const OVERLAY:Class;
		private var mBondingImage:Image = new Image(OVERLAY);
		
		private var fader:NumTween = new NumTween(faderEnd);
		public var completed:Boolean = false;
		
		public function BondingOverlay() 
		{
			graphic = mBondingImage;
			
			setHitboxTo(graphic);
			//mBondingImage.centerOrigin();
			
			addTween(fader);
			fader.value = 1;
		}
		override public function added():void
		{
			fadeIn(0.1);
		}
		
		override public function update():void 
		{
			// Fade in/out alpha control.
			mBondingImage.alpha = fader.value;
			if (fader.value == 1)
			{
				fadeOut(0.5);
			}
			else if (fader.value == 0)
			{
				FP.world.remove(this);
			}
		}
		
		/**
		 * Fades the splash screen in.
		 * @param time	The time the transition will need.
		 */
		private function fadeIn(time:Number=1):void
		{
			fader.tween(fader.value, 1, time, Ease.cubeOut);
			completed = false;
		}
		
		/**
		 * Fades the splash screen out.
		 * @param time	The time the transition will need.
		 */
		private function fadeOut(time:Number=1):void
		{
			fader.tween(fader.value, 0, time, Ease.cubeIn);
			completed = false;
		}
		
		/**
		 * Executes when the fade in/out has finished.
		 */
		private function faderEnd():void 
		{
			completed = true;
		}
	}
}